import { GossipsubMessage } from "@chainsafe/libp2p-gossipsub";
import { EventHandler, StreamHandler } from "@libp2p/interface";
import { TopologyNetworkNodeConfig } from "@topology-foundation/network";
import { TopologyObject } from "@topology-foundation/object";
export interface TopologyNodeConfig {
    networkConfig?: TopologyNetworkNodeConfig;
}
export declare class TopologyNode {
    private _config?;
    private _networkNode;
    private _objectStore;
    constructor(config?: TopologyNodeConfig);
    start(): Promise<void>;
    getPeerId(): string;
    createObject(object: TopologyObject): void;
    subscribeObject(objectId: string): Promise<void>;
    getObject(objectId: string): TopologyObject | undefined;
    updateObject(object: TopologyObject, update_data: string): void;
    addCustomGroup(group: string): void;
    sendGroupMessage(group: string, message: Uint8Array): void;
    addCustomGroupMessageHandler(handler: EventHandler<CustomEvent<GossipsubMessage>>): void;
    addCustomMessageHandler(protocol: string | string[], handler: StreamHandler): void;
}
//# sourceMappingURL=index.d.ts.map